# STM32F429I-DISC1 Discovery board

## Overview

The STM32F429I-DISC1 Discovery kit is a complete demonstration and development platform for STMicroelectronics Arm® Cortex®-M4 core-based STM32F429ZIT6 microcontroller, with 2 Mbyte of flash memory and 256 Kbytes of SRAM.

The full range of hardware features available on the board helps users to enhance their application development by an evaluation of all the peripherals such as 2.4" QVGA TFT LCD, external 64-Mbit SDRAM, ST MEMS gyroscope, USB OTG Micro-AB connector, LEDs and push-buttons.

ST-LINK/V2-B is integrated into the board, as the embedded in-circuit debugger and programmer for the STM32 MCU and USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1670-discovery-kit-with-stm32f429zi-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32F429ZI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32f429zi.html)
- [STM32F429I-DISC1 board](https://www.st.com/en/evaluation-tools/32f429idiscovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1670-discovery-kit-with-stm32f429zi-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/32f429idiscovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1075-f429i-b01_schematic.pdf)
